create or replace
PROCEDURE IMPORTA_NFAPROVADA
IS
   V_NOTAFISCAL INTEGER;
   V_SERIENF    INTEGER;
   V_CDEMPRESA  VARCHAR2(2);
   V_CDINSCESTA VARCHAR2(16);
   V_CDINSCMUNI VARCHAR2(16);
   V_CDFILIAL   VARCHAR2(4);
   V_NRLANCTONF VARCHAR2(10);
   V_NOVONUM    VARCHAR2(20);
   V_IDSTATUS   VARCHAR2(1);
BEGIN
   FOR C_NFAPROVADA IN
      (SELECT U.CDUNICO, U.DTEMISSAO, U.NRACESSONFE, U.IDSTATUSNFE, U.IDINTERFACE, U.TPINTERFACE,
              U.NFENUM, U.SERIES
         FROM USR_SAP_NFAPROVADA U
        WHERE U.DTINTERFACEDEST IS NULL
        ORDER BY U.IDINTERFACE)
   LOOP
      V_CDFILIAL   := SUBSTR(C_NFAPROVADA.CDUNICO, 1, 4);
      V_NRLANCTONF := SUBSTR(C_NFAPROVADA.CDUNICO, 5, 10);
      SELECT COUNT(1)
        INTO V_NOTAFISCAL
        FROM NOTAFISCAL
       WHERE CDFILIAL   = V_CDFILIAL
         AND NRLANCTONF = V_NRLANCTONF;
      IF V_NOTAFISCAL = 1 THEN
         /*Notas fiscais com status "E", no passaro por nenhum validao. A nota apenas dever existir.*/   
         IF (C_NFAPROVADA.IDSTATUSNFE = 'E') THEN
            UPDATE NOTAFISCAL SET IDBLOQUEADO = 'N'
             WHERE CDFILIAL   = V_CDFILIAL
               AND NRLANCTONF = V_NRLANCTONF;

            UPDATE USR_SAP_NFAPROVADA SET DTINTERFACEDEST = SYSDATE, STATUS = 0
             WHERE IDINTERFACE = C_NFAPROVADA.IDINTERFACE;
            
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES (C_NFAPROVADA.IDINTERFACE, 'I', 15, SYSDATE, 0, 'Nota Fiscal '|| C_NFAPROVADA.CDUNICO ||' foi liberada para altera'||CHR(231)||''||CHR(245)||'es no sistema Teknisa com sucesso.');
            
            DELETE FROM USR_SAP_APURFATUR
             WHERE CDUNICO = C_NFAPROVADA.CDUNICO;

            DELETE FROM USR_SAP_ITAPURFATUR
             WHERE CDUNICO = C_NFAPROVADA.CDUNICO;

            DELETE FROM USR_SAP_DADOSADIC
             WHERE CDUNICO = C_NFAPROVADA.CDUNICO;
            COMMIT;
         ELSE
            SELECT CDEMPRESA, CDINSCESTA, CDINSCMUNI
              INTO V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI
              FROM NOTAFISCAL
             WHERE CDFILIAL   = V_CDFILIAL
               AND NRLANCTONF = V_NRLANCTONF;

            SELECT COUNT(1)
              INTO V_SERIENF
              FROM SERIENF
             WHERE CDEMPRESA  = V_CDEMPRESA
               AND CDINSCESTA = V_CDINSCESTA
               AND CDINSCMUNI = V_CDINSCMUNI
               AND CDSERIE    = C_NFAPROVADA.SERIES;
            IF V_SERIENF > 0 THEN
               IF ((C_NFAPROVADA.IDSTATUSNFE = 'C') OR (C_NFAPROVADA.IDSTATUSNFE = 'D')) THEN
                  NOVO_CODIGO('LANCNF/FILIAL' || V_CDFILIAL, V_NOVONUM);
                  V_NOVONUM := SUBSTR(V_NOVONUM, 11, 10);

                  SELECT DECODE(C_NFAPROVADA.IDSTATUSNFE, 'C', 'C', 'D', 'P')
                    INTO V_IDSTATUS
                    FROM DUAL;
                  INSERT INTO NOTAFISCAL(CDFILIAL, NRLANCTONF, CDEMPRESA, CDINSCESTA, CDINSCMUNI, IDTPIJURNF, NRINSJURNF, CDFORNECED,
                                         CDCLIENTE, IDERROS, IDAVISOS, IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC, NRNOTAFISC, DTEMISSAO,
                                         DTENTRSAID, VRPRODUTOS, VRNOTAFISC, DTINIAPUFISC, DTAPROVACAO, CDOPERAPRO, DTCONTABIL, 
                                         NRPLACAVEIC, SGUFVEIC, IDPGTOFRETE, DSQTDEVOLU, DSESPECVOLU, DSMARCAVOLU, DSNUMEVOLU, 
                                         VRPBRUTOVOLU, VRPLIQUVOLU, IDENTRSAIDOP, CDTIPOOPER, CDSERIE, IDTPIJURTRAN, NRINSJURTRAN, 
                                         VRTTMOEDESTR, CDFISOPENTF, DSCDFISOPENF, IDDOCCONTAB, IDSTATUS, NRLANCTBDOC, NRAPURACFAT, 
                                         IDDOCFATUR, IDDOCFISCENT, IDDOCFISCSAI, IDDOCESTOQUE, CDSERIEEMIS, IDSISTEMA, CDMODDOCFISC, 
                                         CDSERIEENTR, CDINTEGRACAO, CDFILIAPFATU, NRAPFATUTNF, NRMRDPAPUR, IDORIGDESTNF, IDDOCREPLIC, 
                                         NRLICENCAUSO, CDFILIALDUP, NRLANCTODUP, DTSAIDEMIS, NRAVISOENTR, DTEXPORTACAO, NRNOTACRED, 
                                         CDFILIMATRIC, CDTURMAPER, NRSEQTURPER, NRMATRICULA, CDFILESTAGIO, CDESTAGIO, CDFILIEMIT, CDFILIRECE,
                                         NRCTRLNFCMP, CDAUTDESPESA, CDALMOXARIFE, CDLOCALESTOQ, CDVENDEDOR, DTLANCAMENNF, DTEMISDOCUAR, 
                                         IDGEROUTDOCU, NREXPEDICAO, CDROTATRANS, NRNOTADEVOL, CDOPERGERA, VRDEVOLNFUTL, DTCOMPFATUR, 
                                         NMRAZSOCNF, CDOPECANCNF, DTCANCELANF, IDIMPONFCR, NRLANCCONT, NRSEQLANC, DSEXCCTBNF, DTEXPRNF, IDJIMPRNF, 
                                         NREXPRNF, DTENTRSAIDANT, CDPTOVNDFATURNF, DTINIREFEFAT, DTFINREFEFAT, IDSTATUSNFE, NRNOTAFISCALELE, 
                                         NRACESSONFE, DSOBSSTATUSNFE, DSMOTIVOCANCNFE, CDEMPLOTENFE, NRLOTENFE, IDIMPRESSODANFE, NRPROTOCOLONFE, 
                                         NRCPFCNPJDFS, CDBARRACONTING, IDEMAILNFE, IDTIPOEMISNFE, NRSEQCAPADOC, CDOPERACTPG, DSNOTAFISORIGOL, 
                                         CDINSCESTAST, IDVERIFNFCONF, CDPARAMEMISRE, NRCPFCNPJNF, CDFILIALRETRO, NRAPURFATNFRETR, IDEXPNFESANAND, 
                                         IDSTATUSCTBNF, IDNFDISPFIN, IDIMPNFPA, IDEXPNFEP, IDTPAMBNFE, DTHRPROTOCOLNFE, IDEMAILNFETRANSP,
                                         IDDEBICREDNF, NRSEQUMAPAPUNF, VRDISPNFDEVO, DTHRREGCONTNFE, NRREGDPECNFE, IDNFGERADAVIAXML, CDSERIERPS, 
                                         NRRPS, NRSEQLOTERPS, IDBLOQNFFIN, CDOPERACTPGCAN, DTCALCRECBRUTA, IDNFCOMPRALEG)
                  SELECT CDFILIAL, V_NOVONUM, CDEMPRESA, CDINSCESTA, CDINSCMUNI, IDTPIJURNF, NRINSJURNF, CDFORNECED,
                         CDCLIENTE, IDERROS, IDAVISOS, 'S', IDDOCFISCAL, IDDOCFINANC, NRNOTAFISC, DTEMISSAO,
                         DTENTRSAID, VRPRODUTOS, VRNOTAFISC, DTINIAPUFISC, DTAPROVACAO, CDOPERAPRO, DTCONTABIL,
                         NRPLACAVEIC, SGUFVEIC, IDPGTOFRETE, DSQTDEVOLU, DSESPECVOLU, DSMARCAVOLU, DSNUMEVOLU,
                         VRPBRUTOVOLU, VRPLIQUVOLU, IDENTRSAIDOP, CDTIPOOPER, CDSERIE, IDTPIJURTRAN, NRINSJURTRAN,
                         VRTTMOEDESTR, CDFISOPENTF, DSCDFISOPENF, IDDOCCONTAB, V_IDSTATUS, NRLANCTBDOC, NRAPURACFAT,
                         IDDOCFATUR, IDDOCFISCENT, IDDOCFISCSAI, IDDOCESTOQUE, CDSERIEEMIS, IDSISTEMA, CDMODDOCFISC,
                         CDSERIEENTR, CDINTEGRACAO, CDFILIAPFATU, NRAPFATUTNF, NRMRDPAPUR, IDORIGDESTNF, IDDOCREPLIC,
                         NRLICENCAUSO, CDFILIALDUP, NRLANCTODUP, DTSAIDEMIS, NRAVISOENTR, DTEXPORTACAO, NRNOTACRED,
                         CDFILIMATRIC, CDTURMAPER, NRSEQTURPER, NRMATRICULA, CDFILESTAGIO, CDESTAGIO, CDFILIEMIT, CDFILIRECE,
                         NRCTRLNFCMP, CDAUTDESPESA, CDALMOXARIFE, CDLOCALESTOQ, CDVENDEDOR, DTLANCAMENNF, DTEMISDOCUAR,
                         IDGEROUTDOCU, NREXPEDICAO, CDROTATRANS, NRNOTADEVOL, CDOPERGERA, VRDEVOLNFUTL, DTCOMPFATUR,
                         NMRAZSOCNF, CDOPECANCNF, DTCANCELANF, IDIMPONFCR, NRLANCCONT, NRSEQLANC, DSEXCCTBNF, DTEXPRNF, IDJIMPRNF,
                         NREXPRNF, DTENTRSAIDANT, CDPTOVNDFATURNF, DTINIREFEFAT, DTFINREFEFAT, C_NFAPROVADA.IDSTATUSNFE, NRNOTAFISCALELE,
                         NRACESSONFE, DSOBSSTATUSNFE, DSMOTIVOCANCNFE, CDEMPLOTENFE, NRLOTENFE, IDIMPRESSODANFE, NRPROTOCOLONFE,
                         NRCPFCNPJDFS, CDBARRACONTING, IDEMAILNFE, IDTIPOEMISNFE, NRSEQCAPADOC, CDOPERACTPG, DSNOTAFISORIGOL,
                         CDINSCESTAST, IDVERIFNFCONF, CDPARAMEMISRE, NRCPFCNPJNF, CDFILIALRETRO, NRAPURFATNFRETR, IDEXPNFESANAND,
                         IDSTATUSCTBNF, IDNFDISPFIN, IDIMPNFPA, IDEXPNFEP, IDTPAMBNFE, DTHRPROTOCOLNFE, IDEMAILNFETRANSP,
                         IDDEBICREDNF, NRSEQUMAPAPUNF, VRDISPNFDEVO, DTHRREGCONTNFE, NRREGDPECNFE, IDNFGERADAVIAXML, CDSERIERPS,
                         NRRPS, NRSEQLOTERPS, IDBLOQNFFIN, CDOPERACTPGCAN, DTCALCRECBRUTA, IDNFCOMPRALEG
                    FROM NOTAFISCAL
                   WHERE CDFILIAL   = V_CDFILIAL
                     AND NRLANCTONF = V_NRLANCTONF;

                  UPDATE NOTAFISCAL
                     SET NRACESSONFE = NULL,
                         NRPROTOCOLONFE = NULL,
                         IDSTATUSNFE = 'P',
                         NRNOTAFISCALELE = NULL,
                         DSOBSSTATUSNFE = NULL,
                         CDEMPLOTENFE = NULL,
                         NRLOTENFE = NULL,
                         IDBLOQUEADO  = 'N',
                         IDSTATUS     = 'P',
                         DTSAIDEMIS   = NULL,
                         DTEMISSAO    = '',
                         NRNOTAFISC   = '',
                         CDOPERAPRO   = NULL,
                         NRLANCTBDOC  = NULL,
                         DTEXPRNF = NULL,
                         NREXPRNF = NULL,
                         IDTIPOEMISNFE  = '0',
                         IDEMAILNFE     = 'P',
                         IDEMAILNFETRANSP = 'P',
                         IDTPAMBNFE     = '0',
                         CDBARRACONTING = NULL,
                         DTHRPROTOCOLNFE = NULL,
                         CDPARAMEMISRE = NULL,
                         NRSEQCAPADOC = NULL,
                         DTHRREGCONTNFE = NULL,
                         NRREGDPECNFE = NULL
                   WHERE CDFILIAL   = V_CDFILIAL
                     AND NRLANCTONF = V_NRLANCTONF;

                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_NFAPROVADA.IDINTERFACE, 'I', 15, SYSDATE, 1, 'Nota Fiscal '|| C_NFAPROVADA.CDUNICO ||' cancelada/denegada no sistema Teknisa com sucesso.');
               ELSE
                  UPDATE NOTAFISCAL SET IDSTATUS = 'A',
                                        IDSTATUSNFE = C_NFAPROVADA.IDSTATUSNFE,
                                        IDBLOQUEADO = 'S',
                                        NRACESSONFE = C_NFAPROVADA.NRACESSONFE,
                                        DTEMISSAO = C_NFAPROVADA.DTEMISSAO,
                                        NRNOTAFISC = C_NFAPROVADA.NFENUM,
                                        NRNOTAFISCALELE = C_NFAPROVADA.NFENUM,
                                        CDSERIE = C_NFAPROVADA.SERIES,
                                        IDNOTAFISIMP = 'S'
                   WHERE CDFILIAL   = V_CDFILIAL
                     AND NRLANCTONF = V_NRLANCTONF;

                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_NFAPROVADA.IDINTERFACE, 'I', 15, SYSDATE, 1, 'Nota Fiscal '|| C_NFAPROVADA.CDUNICO ||' aprovada no sistema Teknisa com sucesso.');
               END IF;

               UPDATE USR_SAP_NFAPROVADA SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                WHERE IDINTERFACE = C_NFAPROVADA.IDINTERFACE;
            ELSE
               IF V_CDINSCMUNI IS NOT NULL THEN
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_NFAPROVADA.IDINTERFACE, 'I', 15, SYSDATE, 1, 'Nota fiscal '|| C_NFAPROVADA.CDUNICO ||' possui a s'||CHR(233)||'rie '|| C_NFAPROVADA.SERIES ||' n'||CHR(227)||'o cadastrada no sistema Teknisa.');

                  UPDATE USR_SAP_NFAPROVADA SET DTINTERFACEDEST = NULL, STATUS = 2
                   WHERE IDINTERFACE = C_NFAPROVADA.IDINTERFACE;
               ELSE
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_NFAPROVADA.IDINTERFACE, 'I', 15, SYSDATE, 1, 'Nota fiscal '|| C_NFAPROVADA.CDUNICO ||' n'||CHR(227)||'o possui inscri'||CHR(231)||CHR(227)|| ' estadual.');

                  UPDATE USR_SAP_NFAPROVADA SET DTINTERFACEDEST = NULL, STATUS = 2
                   WHERE IDINTERFACE = C_NFAPROVADA.IDINTERFACE;
               END IF;
            END IF;
         END IF;
      ELSE
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES (C_NFAPROVADA.IDINTERFACE, 'I', 15, SYSDATE, 1, 'Nota fiscal '|| C_NFAPROVADA.CDUNICO ||' n'||CHR(227)||'o foi encontrada no sistema Teknisa.');

         UPDATE USR_SAP_NFAPROVADA SET DTINTERFACEDEST = NULL, STATUS = 2
          WHERE IDINTERFACE = C_NFAPROVADA.IDINTERFACE;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_NFAPROVADA','6.45.033'); END;
/
